;Bulk-Only Transport interface routines

 include "settings.inc"
  include "../ti83plus.inc"
 include "equates.inc"
 SEGMENT Main
 GLOBALS ON
 EXTERN USBErrorNoDevice,USBErrorClass,IsDeviceConnected,AutoSetupNoInit,USBHostInit,USBErrorInit,USBErrorAutoSetup
 EXTERN GetClass,FindPipe,SendDataSafe,USBReqData,SendControlData,DispHexA,DispHexHL,USBErrorCont,DOS_openFile
 EXTERN DOS_fileRead,DOS_fileWrite,DOS_fileSeek,DOS_createFile,FAT_nameConvertTo11,IPutS,IGetKey
 EXTERN FAT_getStartingCluster,DOS_openFileSC,FAT_findFileInCluster,FAT_nameConvertTo11,Pump,SendControlOut
 EXTERN getMSDPtr,getMSDData

sendCmdOut:
	;Sends a command block out and then sends data in the bulk-only transport protocol
	;Input:      HL points to a command block
       ;            (MSDDataInAddr) is address of data to send
       ;            (MSDDataInExpected) is number of bytes to send
	;            DE is the number of bytes to send
	;C set if there was a problem at any stage
       push hl
       ld hl,(MemPtr)
       ld bc,offFlags
       add hl,bc
       bit flagMSDCBI,(hl)
       pop hl
       jr nz,sendCmdOut_CBI
	ld a,(hl)
	push af
	push hl
	;Build command block wrapper (CBW)
	push de
	call getMSDPtr
	ld hl,MSDBulkBuf
	call getMSDData
	ex de,hl
	ld hl,sendCmd_CBW_Start
	ld bc,8
	ldir
	;dCBWDataTransferLength
	pop de
	pop hl
	push hl
	ld hl,MSDBulkBuf
	call getMSDData
	ld bc,8
	add hl,bc
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	;bmCBWFlags
	inc hl
	ld (hl),0
	;Reserved/bCBWLUN
	inc hl
	ld (hl),0
	;Reserved/bCBWCBLength
	pop de
	pop af
	push de
	and 00011111b
	inc hl
	ld (hl),a
	;CBWCB
	inc hl
	ex de,hl
	pop hl
	inc hl
	ld c,a
	ld b,0
	ldir
	ld b,a
	ld a,16
	sub b
	or a
	jr z,sendCmdO_2
	ld b,a
sendCmdO_1:
	xor a
	ld (de),a
	inc de
	djnz sendCmdO_1
sendCmdO_2:
	;Send CBW!
	ld c,(ix+MSDOutPipe)
	ld b,31
	ld hl,MSDBulkBuf
	call getMSDData
	ld (ix+MSDBOTState),0
	call SendDataSafe
sendCmdOut_Return:
	;Send data now!
	ld l,(ix+MSDDataInAddr)
	ld h,(ix+MSDDataInAddr+1)
sendCmdOut_L:
	ld c,(ix+MSDOutPipe)
	ld b,64
	push hl
	call SendDataSafe
	pop hl
	ld de,64
	add hl,de
	push hl
	ld l,(ix+MSDDataInExpected)
	ld h,(ix+MSDDataInExpected+1)
	or a
	sbc hl,de
	ld (ix+MSDDataInExpected),l
	ld (ix+MSDDataInExpected+1),h
	pop hl
	jr nz,sendCmdOut_L
	ld (ix+MSDBOTState),2
	ld b,(ix+MSDInPipe)
	call USBReqData
	ld hl,0
sendCmdOut_3:
       call Pump
	ld a,(ix+MSDBOTState)
	or a
	ret z
       cp 3
       jr z,sendCmd_Bad
       cp 4
       jr z,sendCmd_Failed
       cp 5
       jr z,sendCmd_Refused
       cp 6
       jr z,sendCmd_NAK
	ld bc,1
	add hl,bc
	jr nc,sendCmdOut_3
sendCmd_Timeout:
       ld a,errMSDCmdTimeout
       jr USBErrorCont
sendCmd_Bad:
       ld a,errMSDSendCmd
       jr USBErrorCont
sendCmd_Failed:
       ld a,errMSDFailedCmd
       jr USBErrorCont
sendCmd_Refused:
       ld a,errMSDCmdRefused ;drive is STALLing
       jr USBErrorCont
sendCmd_NAK:
       ld a,errPort91Bit4 ;drive is NAKing
       jr USBErrorCont
sendCmdOut_CBI:
       ;This might not work (for floppy drives only anyway)
       ;HL points to command block
       ;DE is expected number of bytes to receive in response
       ld a,(hl)
       inc hl
       ex de,hl
       ld hl,sendCmdIn_Setup
       ld b,a
       ;HL is setup packet
       ;DE is command block
       ;B is size of command block
       call SendControlOut
       ret c
       jr sendCmdOut_Return

sendCmdIn:
	;Sends a command block out and receives data in the bulk-only transport protocol
	;Input:      HL points to a command block
       ;            (MSDDataInAddr) is address to receive data
       ;            (MSDDataInExpected) is expected number of bytes to receive
	;            DE is the expected number of bytes to receive
	;Output:     MSDPacketData contains a received packet
	;C is set if there was a problem at any stage.
	;The first byte of the command block is the length (1-16).
	;The remaining bytes are the command block itself.
       push hl
       ld hl,(MemPtr)
       ld bc,offFlags
       add hl,bc
       bit flagMSDCBI,(hl)
       pop hl
       jr nz,sendCmdIn_CBI
	ld a,(hl)
	push af
	push hl
	;Build command block wrapper (CBW)
	push de
	call getMSDPtr
	ld hl,MSDBulkBuf
	call getMSDData
	ex de,hl
	ld hl,sendCmd_CBW_Start
	ld bc,8
	ldir
	;dCBWDataTransferLength
	pop de
	pop hl
	push hl
	ld hl,MSDBulkBuf
	call getMSDData
	ld bc,8
	add hl,bc
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	;bmCBWFlags
	inc hl
	ld (hl),80h
	;Reserved/bCBWLUN
	inc hl
	ld (hl),0
	;Reserved/bCBWCBLength
	pop de
	pop af
	push de
	and 00011111b
	inc hl
	ld (hl),a
	;CBWCB
	inc hl
	ex de,hl
	pop hl
	inc hl
	ld c,a
	ld b,0
	ldir
	ld b,a
	ld a,16
	sub b
	or a
	jr z,sendCmd_2
	ld b,a
sendCmd_1:
	xor a
	ld (de),a
	inc de
	djnz sendCmd_1
sendCmd_2:
	;Send CBW!
	ld hl,MSDBulkBuf
	call getMSDData
	ld c,(ix+MSDOutPipe)
	ld b,31
	call SendDataSafe
sendCmdIn_Return:
	call getMSDPtr
       ld l,(ix+MSDDataInExpected)
       ld a,(ix+MSDDataInExpected+1)
       or l
       jr nz,$F
       ld (ix+MSDBOTState),2
       ld b,(ix+MSDInPipe)
       call USBReqData
       jr sendCmdIn_3
$$:    ld (ix+MSDBOTState),1
	ld b,(ix+MSDInPipe)
	call USBReqData
	ld hl,0
sendCmdIn_3:
       call Pump
	ld a,(ix+MSDBOTState)
	or a
	ret z
       cp 3
       jr z,sendCmd_Bad
       cp 4
       jr z,sendCmd_Failed
       cp 5
       jr z,sendCmd_Refused
       cp 6
       jr z,sendCmd_NAK
	ld bc,1
	add hl,bc
	jr nc,sendCmdIn_3
       jr sendCmd_Timeout
sendCmd_CBW_Start:
	DB 55h,53h,42h,43h
	DB "3.14"
sendCmdIn_CBI:
       ;This might not work (for floppy drives only anyway)
       ;HL points to command block
       ;DE is expected number of bytes to receive in response
       ld a,(hl)
       inc hl
       ex de,hl
       ld hl,sendCmdIn_Setup
       ld b,a
       ;HL is setup packet
       ;DE is command block
       ;B is size of command block
       call SendControlOut
       ret c
       jr sendCmdIn_Return
sendCmdIn_Setup:
       DB 21h,0,0,0,0,0,12,0

       COMMENT ~ This function isn't used anywhere (and some drives freak on it)
sendReset:
	;Send bulk reset command
	;C set if problem
	call getMSDPtr
	push hl
	ld hl,MSDPacketData
	call getMSDData
	ex de,hl
	pop hl
	push de
	ld hl,bulk_reset
	ld bc,8
	ldir
	pop hl
	ld b,0
	jr SendControlData
bulk_reset:
	DB 21h,255,0,0,0,0,0,0
       ~

MSDCallBack:
	;Mass storage driver callback routine
       push ix
       call getMSDPtr
       ld a,(ix+MSDBOTState)
       cp 5
       jr z,MSDCallBackDone
       cp 6
       jr z,MSDCallBackDone
       ld a,b
       ld b,5 ;possibly NAK or Stall
       cp cbStall
       jr z,MSDCallBack_CSW_1
       inc b
       cp cbNak
       jr z,MSDCallBack_CSW_1
	ld a,(ix+MSDBOTState)
       cp 3 ;these may not be necessary, but playing it safe
       jr z,MSDCallBackDone
       cp 4
       jr z,MSDCallBackDone
	dec a ;if 1, then we are waiting for some data to be read
	jr nz,MSDCallBack_CSW
	push de
	ld hl,(MemPtr)
	ld b,0
	ld c,e
	ld e,(ix+MSDDataInAddr)
	ld d,(ix+MSDDataInAddr+1)
	ldir
	ld (ix+MSDDataInAddr),e
	ld (ix+MSDDataInAddr+1),d
	;Calculate if any data left?
	pop de
	ld d,0
	ld l,(ix+MSDDataInExpected)
	ld h,(ix+MSDDataInExpected+1)
	or a
	sbc hl,de
	jr z,MSDCallBack_OK
	jr c,MSDCallBack_OK	;though really not (and this may be unnecessary)
	ld (ix+MSDDataInExpected),l
	ld (ix+MSDDataInExpected+1),h
	ld b,(ix+MSDInPipe)
       pop ix
	jr USBReqData
MSDCallBack_OK:
       ld hl,(MemPtr)
       ld bc,offFlags
       add hl,bc
       bit flagMSDCBI,(hl)
       ld b,(ix+MSDInPipe)
       jr z,$F
       sbc hl,bc
       ld bc,offMSDInterruptPipe
       add hl,bc
       ld b,(hl)
$$:    ld (ix+MSDBOTState),2
       pop ix
       jr USBReqData
MSDCallBack_CSW:
       ld b,0
       ld hl,(MemPtr)
       ld a,(hl)
       ld de,offFlags
       add hl,de
       bit flagMSDCBI,(hl)
       jr nz,MSDCallBack_CSW_1
       sbc hl,de
       cp 'U' ;is this in any way a valid CSW?
       jr z,$F
       ld b,3 ;no, invalid CSW
       jr MSDCallBack_CSW_1
$$:    ld de,12
       add hl,de
       ld a,(hl)
       or a
       jr z,MSDCallBack_CSW_1
       ld b,4 ;valid but error-holding CSW
MSDCallBack_CSW_1:
       ld (ix+MSDBOTState),b
MSDCallBackDone:
       pop ix
	ret
