 include "settings.inc"
  include "../ti83plus.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON


INewLine:
       push   af
       push   bc
       push   de
       push   hl
       B_CALL NewLine
       pop    hl
       pop    de
       pop    bc
       pop    af
       ret

ILdHLInd:
       ld     a,(hl)
       inc    hl
       ld     h,(hl)
       ld     l,a
       ret

NegHL:
       ld     a,h
       cpl    
       ld     h,a
       ld     a,l
       cpl    
       ld     l,a
       inc    hl
       ret


CpHLDE:
       push   hl
       or     a
       sbc    hl,de
       pop    hl
       ret
 COMMENT ~
GetByteSerial:
       push   bc
       ld     b,0
$$:
       call   GetByteSerial2
       jr     nz,GetByteSerialDone
       djnz   $b
GetByteSerialDone:
       pop    bc
       ret

GetByteSerial2:
       in     a,(9)
       and    00011000b
       ret    z
       in     a,(0Ah)
       ld     c,0
       inc    c
       ret
 ~

IGetKey:
       push   bc
       push   de
       push   hl
       res    onInterrupt,(iy+onFlags)
       B_CALL GetKey
       pop    hl
       pop    de
       pop    bc
       ret

IPutSUnicode:
;Display a unicode string descriptor:
       ld     b,(hl)
       inc    hl
       inc    hl
       dec    b
       dec    b
$$:
       ld     a,(hl)
       or     a
       call   nz,IPutC
       inc    hl
       djnz   $b
       ret

IPutS:
       ld     a,(hl)
       inc    hl
       or     a
       ret    z
       call   IPutC
       jr     IPutS

IPutC:
       push   hl
       push   bc
       B_CALL PutC
       pop    bc
       pop    hl
       ret
       

DispHexHL:
       ld     a,h
       call   DispHexA
       ld     a,l
       jp     DispHexA
Disp4HL:
       ld     a,(hl)
       call   DispHexA
       inc    hl
       ld     a,(hl)
       call   DispHexA
       inc    hl
Disp2HL:
       ld     a,(hl)
       call   DispHexA
       inc    hl
       ld     a,(hl)
       inc    hl
DispHexA:
	push	af
        push    hl
        push    bc
        push    af
        rrca
        rrca
        rrca
        rrca
        call    dispha
        pop     af
        call      dispha
        pop     bc
        pop     hl
	pop	af
        ret
dispha:
        and     15
        cp      10
        jp      nc,dhlet
        add     a,48
        jp      dispdh
dhlet:
        add     a,55
dispdh:
       call   IPutC
        ret







WaitTimer32:
       call   WaitTimer16
WaitTimer16:
       call   WaitTimer8
WaitTimer8:
       call   WaitTimer4
WaitTimer4:
       call   WaitTimer2
WaitTimer2:
       call   WaitTimer1
WaitTimer1:
;Waits for about 10ms?
       push   bc
       ld     b,1
       call   WaitTimerB
       pop    bc
       ret
WaitTimerB:
	ld	a,42h
	out	(36h),a
	xor	a
	out	(37h),a
	ld	a,b
	out	(38h),a
$$:
	in	a,(4)
	bit	7,a
	jr	z,$b
       or     a
	ret

DelayB:
       halt
       djnz   DelayB
       ret

strlen:
	;Gets length of string pointed to by HL in B
	ld b,0
$$:    ld a,(hl)
	or a
	ret z
	inc b
	inc hl
	jr $B

ConvOP1:
	;Gets a number out of OP1
	;Returns C if the number was too large
	ld b,5
	ld de,0
ConvOP1_Loop:
	push bc
	xor a
	ld hl,OP1+4
	rld
	dec hl
	rld
	dec hl
	rld
	ex de,hl
	add hl,hl
	push hl
	add hl,hl
	add hl,hl
	jr c,ConvOP1_Return2
	pop bc
	add hl,bc
	jr c,ConvOP1_Return
	;HL is times 10
	ld b,0
	ld c,a
	add hl,bc
	ex de,hl
	dec hl
	pop bc
	dec (hl)
	ret p
	djnz ConvOP1_Loop
	scf
	ret
ConvOP1_Return2:
	pop bc
ConvOP1_Return:
	pop bc
	ret
